//Original credits
//Kalphiter: Non-blocking autosaver (Was privately used by Kaphost)
//Zack0wack0: Blocking autosaver
//Randy: Basic saving function

//Heavily remodified by Visolator/Kyuande
function Server_Autosaver_PrefInit()
{
	if(!$Server::AS::Init)
	{
		if(isFunction(RTB_registerPref))
		{
			RTB_registerPref("Announce", "Autosaver", "$Pref::Server::AS::Announce", "bool", "Support_AutoSaver", 1, 0, 0);
			RTB_registerPref("Echo progress", "Autosaver", "$Pref::Server::AS::Echo", "bool", "Support_AutoSaver", 1, 0, 0);
			RTB_registerPref("Folder location", "Autosaver", "$Pref::Server::AS::Directory", "string 50 50", "Support_AutoSaver", "saves/AutoSaver/", 0, 0);
			RTB_registerPref("Announce savename", "Autosaver", "$Pref::Server::AS::AnnounceSaveName", "bool", "Support_AutoSaver", 1, 0);
			RTB_registerPref("Interval", "Autosaver", "$Pref::Server::AS::Interval", "int 0 16", "Support_AutoSaver", 5, 0, 0);
			RTB_registerPref("Report stats", "Autosaver", "$Pref::Server::AS::Report", "bool", "Support_AutoSaver", 1, 0, 0);
			RTB_registerPref("Save events", "Autosaver", "$Pref::Server::AS::SaveEvents", "bool", "Support_AutoSaver", 1, 0, 0);
			RTB_registerPref("Save ownership", "Autosaver", "$Pref::Server::AS::SaveOwnership", "bool", "Support_AutoSaver", 1, 0, 0);
			RTB_registerPref("Overwrite temp save", "Autosaver", "$Pref::Server::AS::OverwriteSave", "bool", "Support_AutoSaver", 0, 0, 0);
			RTB_registerPref("Autoload save on start", "Autosaver", "$Pref::Server::AS::Autoload", "bool", "Support_AutoSaver", 1, 0, 0);
			RTB_registerPref("Autosave duplicates", "Autosaver", "$Pref::Server::AS::SaveRelatedBrickcount", "bool", "Support_AutoSaver", 0, 0, 0);
			RTB_registerPref("Autosave restart mode", "Autosaver", "$Pref::Server::AS::AutoLoad_RestartMode", "list AfterSaveLoad 0 IntervalAfterSaveLoad 1", "Support_AutoSaver", 1, 0, 0);
			RTB_registerPref("Show progress", "Autosaver", "$Pref::Server::AS::Progress", "list No 0 CenterPrint 1", "Support_AutoSaver", 0, 0, 0);
		}
		else if(isFunction(ORBS_registerPref))
		{
			ORBS_registerPref("Announce", "Autosaver", "$Pref::Server::AS::Announce", "bool", "Support_AutoSaver", 1, 0, 0);
			ORBS_registerPref("Echo progress", "Autosaver", "$Pref::Server::AS::Echo", "bool", "Support_AutoSaver", 1, 0, 0);
			ORBS_registerPref("Folder location", "Autosaver", "$Pref::Server::AS::Directory", "string 50 50", "Support_AutoSaver", "saves/AutoSaver/", 0, 0);
			ORBS_registerPref("Announce savename", "Autosaver", "$Pref::Server::AS::AnnounceSaveName", "bool", "Support_AutoSaver", 1, 0);
			ORBS_registerPref("Interval", "Autosaver", "$Pref::Server::AS::Interval", "int 0 16", "Support_AutoSaver", 5, 0, 0);
			ORBS_registerPref("Report stats", "Autosaver", "$Pref::Server::AS::Report", "bool", "Support_AutoSaver", 1, 0, 0);
			ORBS_registerPref("Save events", "Autosaver", "$Pref::Server::AS::SaveEvents", "bool", "Support_AutoSaver", 1, 0, 0);
			ORBS_registerPref("Save ownership", "Autosaver", "$Pref::Server::AS::SaveOwnership", "bool", "Support_AutoSaver", 1, 0, 0);
			ORBS_registerPref("Overwrite temp save", "Autosaver", "$Pref::Server::AS::OverwriteSave", "bool", "Support_AutoSaver", 0, 0, 0);
			ORBS_registerPref("Autoload save on start", "Autosaver", "$Pref::Server::AS::Autoload", "bool", "Support_AutoSaver", 1, 0, 0);
			ORBS_registerPref("Autosave duplicates", "Autosaver", "$Pref::Server::AS::SaveRelatedBrickcount", "bool", "Support_AutoSaver", 0, 0, 0);
			ORBS_registerPref("Autosave restart mode", "Autosaver", "$Pref::Server::AS::AutoLoad_RestartMode", "list AfterSaveLoad 0 IntervalAfterSaveLoad 1", "Support_AutoSaver", 1, 0, 0);
			ORBS_registerPref("Show progress", "Autosaver", "$Pref::Server::AS::Progress", "list No 0 CenterPrint 1", "Support_AutoSaver", 0, 0, 0);
		}
		else
		{
			if($Pref::Server::AS::Directory $= "")
				$Pref::Server::AS::Directory = "saves/AutoSaver/";

			if($Pref::Server::AS::Announce $= "")
				$Pref::Server::AS::Announce = true;

			if($Pref::Server::AS::AnnounceSaveName $= "")
				$Pref::Server::AS::AnnounceSaveName = true;

			if($Pref::Server::AS::Interval $= "")
				$Pref::Server::AS::Interval = 5;

			if($Pref::Server::AS::Report $= "")
				$Pref::Server::AS::Report = true;

			if($Pref::Server::AS::SaveEvents $= "")
				$Pref::Server::AS::SaveEvents = true;

			if($Pref::Server::AS::SaveOwnership $= "")
				$Pref::Server::AS::SaveOwnership = true;

			if($Pref::Server::AS::OverwriteSave $= "")
				$Pref::Server::AS::OverwriteSave = true;

			if($Pref::Server::AS::Autoload $= "")
				$Pref::Server::AS::Autoload = true;

			if($Pref::Server::AS::SaveRelatedBrickcount $= "")
				$Pref::Server::AS::SaveRelatedBrickcount = false;

			if($Pref::Server::AS::AutoLoad_RestartMode $= "")
				$Pref::Server::AS::AutoLoad_RestartMode = 1;

			if($Pref::Server::AS::Progress $= "")
				$Pref::Server::AS::Progress = 0;

			if($Pref::Server::AS::Echo $= "")
				$Pref::Server::AS::Echo = true;

			if($Pref::Server::AS::OverwriteOnChange $= "")
				$Pref::Server::AS::OverwriteOnChange = true;
		}
	}

	$Server::AS::Init = 1;
}
schedule(0, 0, "Server_Autosaver_PrefInit");

//GuiTextListCtrl

package Server_Autosaver
{
	function ServerLoadSaveFile_End()
	{
		Parent::ServerLoadSaveFile_End();
		Server_Autosaver_Restart();
   	}

   	function fxDtsBrick::setColor(%this, %id)
   	{
   		$Server::AS["BrickChanged"] = 1;
   		Parent::setColor(%this, %id);
   	}

   	function fxDtsBrick::setColorFX(%this, %id)
   	{
   		$Server::AS["BrickChanged"] = 1;
   		Parent::setColorFX(%this, %id);
   	}

   	function fxDtsBrick::setItem(%this, %id, %c)
   	{
   		$Server::AS["BrickChanged"] = 1;
   		return Parent::setItem(%this, %id, %c);
   	}

   	function fxDtsBrick::setLight(%this, %id, %c)
   	{
   		$Server::AS["BrickChanged"] = 1;
   		return Parent::setLight(%this, %id, %c);
   	}

   	function fxDtsBrick::setEmitter(%this, %id, %c)
   	{
   		$Server::AS["BrickChanged"] = 1;
   		return Parent::setEmitter(%this, %id, %c);
   	}

   	function fxDtsBrick::setItemDirection(%this, %id, %c)
   	{
   		$Server::AS["BrickChanged"] = 1;
   		return Parent::setItemDirection(%this, %id, %c);
   	}

   	function fxDtsBrick::setItemPosition(%this, %id, %c)
   	{
   		$Server::AS["BrickChanged"] = 1;
   		return Parent::setItemPosition(%this, %id, %c);
   	}

   	function fxDtsBrick::setItemRespawnTime(%this, %time, %c)
   	{
   		$Server::AS["BrickChanged"] = 1;
   		return Parent::setItemRespawnTime(%this, %time, %c);
   	}

   	function fxDtsBrick::setNTObjectName(%this, %name)
   	{
   		$Server::AS["BrickChanged"] = 1;
   		return Parent::setNTObjectName(%this, %name);
   	}

   	function fxDtsBrick::setVehicle(%this, %vehicle, %c)
   	{
   		$Server::AS["BrickChanged"] = 1;
   		return Parent::setVehicle(%this, %vehicle, %c);
   	}
};
activatePackage("Server_Autosaver");

function Server_Autosaver_Restart()
{
	cancel($Server_AS_schedule);
	if($Server::AS::Debug)
		announce("\c6[\c0!\c6] \c3Server_Autosaver_Restart() - Starting save loop");

	if($Pref::Server::AS::AutoLoad_RestartMode == 1)
		$Server_AS_schedule = schedule((($Pref::Server::AS::Interval | 0) * 60000 | 0), 0, "Server_AS1_begin"); //Save based on interval time.
	else
		Server_AS1_begin(); //Save right away.
}

function Server_AutoloadSave()
{
	if(!$Pref::Server::AS::Autoload)
		return;

	announce("\c6Autoloading last autosaved build.");
	if($Pref::Server::AS["LastAutoSave"] !$= "")
		loadAutoSaveBuild($Pref::Server::AS["LastAutoSave"]);
}

if(!$Server::AS::HasAutoLoaded)
{
	$Server::AS::HasAutoLoaded = 1;
	schedule(5000, 0, "Server_AutoloadSave");
}

function serverCmdAutoSaveBricks(%this, %msg0, %msg1, %msg2, %msg3, %msg4, %msg5, %msg6, %msg7, %msg8, %msg9)
{
	if(!%this.isSuperAdmin)
		return;

	if($Server::AS::IsInUse)
	{
		%this.chatMessage("Server is currently autosaving.");
		return;
	}

	for(%i = 0; %i < 9; %i++)
	{
		if(%msg[%i] !$= "")
		{
			if(%msg $= "")
				%msg = %msg[%i];
			else
				%msg = %msg SPC %msg[%i];
		}
	}

	%msg = stripMLControLChars(%msg);
	%name = strReplace(%msg, "\"", "");

	echo(%this.getPlayerName() @ " is attempting to autosave bricks." @ (%name !$= "" ? " Custom name: \"" @ %name @ "\"" : ""));
	announce("\c6[\c0!\c6] \c3" @ %this.getPlayerName() @ " \c6is attempting to autosave bricks." @ (%name !$= "" ? " Custom name: \"\c3" @ %name @ "\c6\"" : ""));

	Server_AS1_begin(%name);
}

function serverCmdAutoloadBricksID(%this, %bl_id, %msg0, %msg1, %msg2, %msg3, %msg4, %msg5, %msg6, %msg7, %msg8, %msg9)
{serverCmdLoadAutoSaveID(%this, %bl_id, %msg0, %msg1, %msg2, %msg3, %msg4, %msg5, %msg6, %msg7, %msg8, %msg9);}

function serverCmdLoadAutoSaveID(%this, %bl_id, %msg0, %msg1, %msg2, %msg3, %msg4, %msg5, %msg6, %msg7, %msg8, %msg9)
{
	if(!%this.isSuperAdmin)
		return;

	for(%i = 0; %i < 9; %i++)
	{
		if(%msg[%i] !$= "")
			%msg = %msg SPC %msg[%i];
	}

	%msg = stripMLControLChars(%msg);
	%msg = strReplace(%msg, "\"", "");

	if(%msg $= "last")
	{
		echo(%this.getPlayerName() @ " is attempting to load bricks from the last autosave file for BL_ID: " @ %bl_id @ ".");
		announce("\c6[\c0!\c6] \c3" @ %this.getPlayerName() @ " \c6is attempting to load bricks from the last autosave file for BL_ID: " @ %bl_id @ ".");
	}
	else
	{
		echo(%this.getPlayerName() @ " is attempting to load bricks from an autosave file for BL_ID: " @ %bl_id @ ". - " @ %msg);
		announce("\c6[\c0!\c6] \c3" @ %this.getPlayerName() @ " \c6is attempting to load bricks from an autosave file for BL_ID: " @ %bl_id @ ". \c7- \c4" @ %msg);
	}

	loadAutoSaveBuildID(%msg, %bl_id);
}

function serverCmdAutoloadBricks(%this, %msg0, %msg1, %msg2, %msg3, %msg4, %msg5, %msg6, %msg7, %msg8, %msg9)
{serverCmdLoadAutoSave(%this, %msg0, %msg1, %msg2, %msg3, %msg4, %msg5, %msg6, %msg7, %msg8, %msg9);}

function serverCmdLoadAutoSave(%this, %msg0, %msg1, %msg2, %msg3, %msg4, %msg5, %msg6, %msg7, %msg8, %msg9)
{
	if(!%this.isSuperAdmin)
		return;

	for(%i = 0; %i < 9; %i++)
	{
		if(%msg[%i] !$= "")
			%msg = %msg SPC %msg[%i];
	}

	%msg = trim(stripMLControLChars(%msg));
	%msg = strReplace(%msg, "\"", "");

	if(%msg $= "last")
	{
		echo(%this.getPlayerName() @ " is attempting to load bricks from the last autosave file.");
		announce("\c6[\c0!\c6] \c3" @ %this.getPlayerName() @ " \c6is attempting to load bricks from the last autosave file.");
		Server_AutoloadSave();
		return;
	}
	else
	{
		echo(%this.getPlayerName() @ " is attempting to load bricks from an autosave file. - " @ %msg);
		announce("\c6[\c0!\c6] \c3" @ %this.getPlayerName() @ " \c6is attempting to load bricks from an autosave file. \c7- \c4" @ %msg);
	}

	loadAutoSaveBuild(%msg);
}

function Server_AS_SetState(%state)
{
	if(%state $= "")
		return;

	if($Server::AS::State $= %state)
		return;

	$Server::AS::State = %state;
	if($Server::AS::Debug)
	{
		announce("\c6[\c0!\c6] \c3Server_AS_SetState() - Mode set to \c2" @ %state);
		echo("Server_AS_SetState() - Mode set to \c2" @ %state);
	}
}

function Server_AS_Split(%fileName, %toFilePath)
{
	
}

function loadAutoSaveBuildPath(%path)
{	
	if(!isFile(%path))
	{
		announce("loadAutoSaveBuildPath() - invalid save file (" @ %path @ ")");
		return;
	}

	if(fileExt(%path) !$= ".bls")
	{
		announce("loadAutoSaveBuildPath() - invalid save (" @ %path @ ")");
		return;
	}

	cancel($Server_AS_schedule);

	//Put it as a temp file in case they have to reload it
	fileCopy(%path, "base/server/temp/temp.bls");
	
	%quotaObj = getCurrentQuotaObject();
	clearCurrentQuotaObject();
	serverDirectSaveFileLoad(%path, 3, "", 1);
	if(isObject(%quotaObj))
		setCurrentQuotaObject(%quotaObj);
}

function loadAutoSaveBuild(%name)
{	
	%path = $Pref::Server::AS::Directory @ %name @ ".bls";
	if(!isFile(%path))
	{
		announce("loadAutoSaveBuild() - invalid save (" @ %path @ ")");
		return;
	}

	cancel($Server_AS_schedule);
	//Put it as a temp file in case they have to reload it
	fileCopy(%path, "base/server/temp/temp.bls");
	
	%quotaObj = getCurrentQuotaObject();
	clearCurrentQuotaObject();
	serverDirectSaveFileLoad(%path, 3, "", 1);
	if(isObject(%quotaObj))
		setCurrentQuotaObject(%quotaObj);
}

function loadAutoSaveBuildID(%name, %bl_id)
{	
	if(%name $= "last" && $Pref::Server::AS["LastAutoSave"] !$= "")
	{
		%path = $Pref::Server::AS::Directory @ $Pref::Server::AS["LastAutoSave"] @ ".bls";
		%writePath = $Pref::Server::AS::Directory @ $Pref::Server::AS["LastAutoSave"] @ "TEMPBL_ID.bls";
	}
	else
	{
		%path = $Pref::Server::AS::Directory @ %name @ ".bls";
		%writePath = $Pref::Server::AS::Directory @ "TEMPBL_ID.bls";
	}

	%bl_id = mFloor(%bl_id);
	if(!isFile(%path))
	{
		announce("loadAutoSaveBuildID() - invalid save (" @ %path @ ")");
		return;
	}

	%io2 = new FileObject();
	%io2.openForRead(%path);
	%start = false;
	while(!%io2.isEOF())
	{
		%line = %io2.readLine();
		%type = getWord(%line, 0);
		if(%type $= "Linecount" && !%start)
			%start = true;

		if(%start)
		{
			if(%type $= "+-OWNER" && getWord(%line, 1) == %bl_id)
				%bl_idCount++;
		}
	}
	%io2.close();
	%io2.delete();

	if(%bl_idCount <= 0)
	{
		announce("loadAutoSaveBuildID() - no bl_id ownership for " @ %bl_id);
		return;
	}

	//Write a new thing
	%io = new FileObject();
	%io.openForWrite(%writePath);
	%io.writeLine("This is a Blockland save file.  You probably shouldn't modify it cause you'll screw it up.  This is an autosave file.");
	%io.writeLine("1");
	%io.writeLine(%desc);

	for(%i = 0; %i < 64; %i++)
		%io.writeLine(getColorIDTable(%i));

	%io.writeLine("Linecount " @ %bl_idCount);

	%io2 = new FileObject();
	%io2.openForRead(%path);
	%start = false;
	while(!%io2.isEOF())
	{
		%line = %io2.readLine();
		%type = getWord(%line, 0);
		if(%type $= "Linecount" && !%start)
			%start = true;

		if(%start)
		{
			if(%type !$= "+-OWNER" && %type !$= "+-ITEM" && %type !$= "+-NTOBJECTNAME" && %type !$= "+-EMITTER" && %type !$= "+-LIGHT" && %type !$= "+-AUDIOEMITTER" && %type !$= "+-VEHICLE" && strPos(%line, "\"") >= 0)
			{
				%writeMode = 0;
				%lastBrickLine = %line;
			}
			else if(%lastBrickLine !$= "" && %type $= "+-OWNER" && getWord(%line, 1) == %bl_id)
			{
				%writeMode = 1;
				%io.writeLine(%lastBrickLine);
				%io.writeLine("+-OWNER " @ %bl_id);
			}
			else if(%type !$= "+-OWNER" && %writeMode)
				%io.writeLine(%line);
		}
	}
	%io2.close();
	%io2.delete();

	%io.close();
	%io.delete();

	cancel($Server_AS_schedule);
	//Put it as a temp file in case they have to reload it
	fileCopy(%writePath, "base/server/temp/temp.bls");
	
	%quotaObj = getCurrentQuotaObject();
	clearCurrentQuotaObject();
	serverDirectSaveFileLoad(%writePath, 3, "", 1);
	if(isObject(%quotaObj))
		setCurrentQuotaObject(%quotaObj);
}

function Server_AS1_begin(%name)
{
	cancel($Server_AS_schedule);
	Server_AS_SetState("(AS1) Save init");
	echo("[AutoSaver] - Attempting to autosave bricks...");
	if($Pref::Server::AS::SaveOwnership)
		echo("  - Ownership");
	if($Pref::Server::AS::SaveEvents)
		echo("  - Events");

	deleteVariables("$Server::AS_groups::group*");
	if(!isObject($Server::AS::SaveObject))
		$Server::AS::SaveObject = new GuiTextListCtrl("Server_AutosaverList");
	else
		$Server::AS::SaveObject.clear();

	$CurAutoSaveName = %name;

	if(getBrickCount() <= 0)
	{
		Server_AS_SetState("(AS1) No bricks");
		announce("\c6[\c0!\c6] \c6There are no bricks to autosave.");
		echo("[AutoSaver] - No bricks to autosave.");
		$Server_AS_schedule = schedule((($Pref::Server::AS::Interval | 0) * 60000 | 0), 0, "Server_AS1_begin");
		return;
	}

	$Server::AS::IsInUse = 1;

	if($Pref::Server::AS::Announce)
	{
		%eventMsg = ($Pref::Server::AS::SaveEvents ? "\c6[\c4Events\c6]" : "");
		%ownerMsg = ($Pref::Server::AS::SaveOwnership ? "\c6[\c4Ownership\c6]" : "");
		%autosaveMsg = ($Pref::Server::AS::SaveEvents ? ($Pref::Server::AS::SaveOwnership ? "\c3Events and ownership" : "\c3Events") : ($Pref::Server::AS::SaveOwnership ? "\c3Ownership" : ""));
		announce("\c6[\c0!\c6] \c6Autosaving bricks... " @ (%autosaveMsg !$= "" ? "\c6(" @ %autosaveMsg @ "\c6)" : ""));
	}

	$time_beg = getSimTime();

	%dir = $Pref::Server::AS::Directory;
	$Server::AS_groups::group_count = 0;
	$Server::AS_groups::cur_group = 0;
	$Server::AS_groups::brick_count = 0;
	$Server::AS_groups::event_count = 0;

	Server_AS_SetState("(AS1) Save - Collecting");
	for(%i = 0; %i < mainBrickGroup.getCount(); %i++)
	{
		%g = mainBrickGroup.getObject(%i);
		%b = %g.getCount();
		if(%b > 0)
		{
			%g.Server_AS_stop = %b;
			$Server::AS_groups::group[$Server::AS_groups::group_count] = %g;
			$Server::AS_groups::group_count++;
		}
	}

	Server_AS_SetState("(AS1) Save - Finished collecting");

	if(isObject($Server::AS_groups::group[0]))
	{
		Server_AS_SetState("(AS1) Begin to save " @ $Server::AS_groups::group_count @ " group" @ ($Server::AS_groups::group_count != 1 ? "s" : ""));
		Server_AS1_nextGroup();
	}
	else
	{
		if($Pref::Server::AS::Interval < 5)
			$Pref::Server::AS::Interval = 1;

		if($Pref::Server::AS::Interval > 16)
			$Pref::Server::AS::Interval = 16;

		%diff = (getSimTime() - $time_beg);

		if($Pref::Server::AS::Announce)
		{
			announce("\c6[\c0!\c6] \c6There are no bricks to autosave.");
			echo("[AutoSaver] - No bricks to autosave.");
		}

		%next_time = 60 * 1000 - %diff;
		%next_time = (($Pref::Server::AS::Interval | 0) * 60000 | 0) - %diff;
		if(%next_time < 60000)
			%next_time = (($Pref::Server::AS::Interval | 0) * 60000 | 0);

		$Server_AS_schedule = schedule(%next_time, 0, "Server_AS1_begin");
	}
}

function Server_AS1_nextGroup()
{
	if(!$Server::AS::IsInUse)
		return;

	if($Server::AS_groups::cur_group == $Server::AS_groups::group_count)
	{
		%count = $Server::AS::SaveObject.rowCount();
		Server_AS_SetState("(AS1) Saved " @ %count @ " brick" @ (%count != 1 ? "s" : "") @ ", sorting");
		$Server::AS::SaveObject.sortNumerical(0, 1);
		return Server_AS2_begin();
	}

	%g = $Server::AS_groups::group[$Server::AS_groups::cur_group];
	$Server::AS_groups::cur_group++;

	Server_AS1_nextBrick(%g, 0);
}

function Server_AS1_nextBrick(%g, %c)
{
	if(!$Server::AS::IsInUse)
		return;

	if(!isObject(%g))
		return;

	if(%c >= %g.getCount())
		return Server_AS1_nextGroup();

	%brick = nameToID(%g.getObject(%c));

	if(!isObject($Server::AS::SaveObject))
		return;

	if(%brick.isPlanted)
	{
		if($Server::AS::SaveObject.getRowNumByID(%brick) == -1)
			$Server::AS::SaveObject.addRow(%brick, %brick.getDistanceFromGround());
	}
	else if(isObject(%brick))
	{
		%del = 1;
		for(%i = 0; %i < ClientGroup.getCount(); %i++)
		{
			if(ClientGroup.getObject(%i).player.tempBrick == %brick)
				%del = 0;
		}

		if(%del) //This helps delete unwanted temp bricks that don't belong to anyone
			%brick.schedule(0, "delete");
	}

	//if($Pref::Server::AS::SlowDownAfter > 0 && %c > $Pref::Server::AS::SlowDownAfter)
	//	return schedule(1, 0, "Server_AS1_nextBrick", %g, %c + 1);
		
	return schedule(0, 0, "Server_AS1_nextBrick", %g, %c + 1);
}

function Server_AS2_begin()
{
	$Server::AS::LastPrint = "";
	Server_AS_SetState("(AS2) Write init");

	%dir = $Pref::Server::AS::Directory;

	if(isObject($Server::AS::TempB))
	{
		$Server::AS::TempB.close();
		$Server::AS::TempB.delete();
	}

	if(!$Server::AS::IsInUse)
		return;

	$Server::AS::TempB = new FileObject();

	$Server::AS::TempB.path = %dir @ "SAVETEMP.bls";

	$Server::AS::TempB.openForWrite($Server::AS::TempB.path);
	$Server::AS::TempB.writeLine("This is a Blockland save file.  You probably shouldn't modify it cause you'll mess it up.");
	$Server::AS::TempB.writeLine("1");
	$Server::AS::TempB.writeLine(%desc);

	for(%i = 0; %i < 64; %i++)
		$Server::AS::TempB.writeLine(getColorIDTable(%i));

	$Server::AS::TempB.writeLine("Linecount " @ $Server::AS::SaveObject.rowCount());

	$Server::AS::Brickcount = 0;
	$Server::AS::Eventcount = 0;
	Server_AS2_nextLine($Server::AS::TempB, 0);
}

function Server_AS2_nextLine(%f, %c)
{
	if(!$Server::AS::IsInUse)
	{
		if(isObject(%f))
		{
			%f.close();
			%f.delete();
		}

		return;
	}

	%events = $Pref::Server::AS::SaveEvents;
	%ownership = $Pref::Server::AS::SaveOwnership;
	%count = $Server::AS::SaveObject.rowCount();

	if($Pref::Server::AS::Progress == 1)
	{
		%newPrint = "<just:right>\c6-\c6Autosaver\c6- <br>\c6Saved: \c3" @ mFloatLength(%c / %count * 100, 1) @ "% ";

		if($Server::AS::LastPrint !$= %newPrint)
		{
			$Server::AS::LastPrint = %newPrint;
			centerPrintAll(%newPrint, 3);
		}
	}

	if(%c < %count)
	{
		%brick = $Server::AS::SaveObject.getRowID(%c);
		if(isObject(%brick))
		{
			$Server::AS::Brickcount++;
			if(%brick.getDataBlock().hasPrint)
			{
				%texture = getPrintTexture(%brick.getPrintId());
				%path = filePath(%texture);
				%underscorePos = strPos(%path, "_");
				%name = getSubStr(%path, %underscorePos + 1, strPos(%path, "_", 14) - 14) @ "/" @ fileBase(%texture);
				if($printNameTable[%name] !$= "")
					%print = %name;
			}

			%f.writeLine(%brick.getDataBlock().uiName @ "\" " @ %brick.getPosition() SPC %brick.getAngleID() SPC %brick.isBasePlate() SPC %brick.getColorID() 
				SPC %print SPC %brick.getColorFXID() SPC %brick.getShapeFXID() SPC %brick.isRayCasting() SPC %brick.isColliding() SPC %brick.isRendering());

			if(%ownership && !$Server::LAN)
			{
				%tempID = getBrickGroupFromObject(%brick).bl_id;
				if(%tempID $= "")
					%noBLID = 1;

				%f.writeLine("+-OWNER " @ %tempID);
			}

			if(%events)
			{
				if(%brick.getName() !$= "")
					%f.writeLine("+-NTOBJECTNAME " @ %brick.getName());

				for(%b = 0; %b < %brick.numEvents; %b++)
				{
					$Server::AS::Eventcount++;
					//Get rid of this garbage code
					//%targetClass = %brick.eventTargetIdx[%b] >= 0 ? getWord(getField($InputEvent_TargetListfxDTSBrick_[%brick.eventInputIdx[%b]], %brick.eventTargetIdx[%b]), 1) : "fxDtsBrick";
					//%paramList = $OutputEvent_parameterList[%targetClass, %brick.eventOutputIdx[%b]];
					//for(%j = 1; %j < 4; %j++)
					//{
					//	%curParam = %brick.eventOutputParameter[%b, %j];
					//	if(getWordCount(%curParam) == 1 && isObject(%curParam))
					//		if((%curParamName = %curParam.getName()) !$= "")
					//			%curParam = %curParamName;

					//	%params = %params TAB %curParam;
					//}

					%params = getFields(%brick.serializeEventToString(%b), 7, 10);
					%f.writeLine("+-EVENT" TAB %b TAB %brick.eventEnabled[%b] TAB %brick.eventInput[%b] TAB %brick.eventDelay[%b] TAB %brick.eventTarget[%b] 
						TAB %brick.eventNT[%b] TAB %brick.eventOutput[%b] TAB %params);
				}
			}
			
			if(isObject(%emitter = %brick.emitter) && isObject(%emitterData = %emitter.getEmitterDatablock()) && (%emitterName = %emitterData.uiName) !$= "")
				%f.writeLine("+-EMITTER " @ %emitterName @ "\" " @ %brick.emitterDirection);

			if(isObject(%light = %brick.getLightID()) && isObject(%lightData = %light.getDataBlock()) && (%lightName = %lightData.uiName) !$= "")
				%f.writeLine("+-LIGHT " @ %lightName @ "\" "); // Not sure if something else comes after the name

			if(isObject(%item = %brick.item) && isObject(%itemData = %item.getDataBlock()) && (%itemName = %itemData.uiName) !$= "")
				%f.writeLine("+-ITEM " @ %itemName @ "\" " @ %brick.itemPosition SPC %brick.itemDirection SPC %brick.itemRespawnTime);

			if(isObject(%audioEmitter = %brick.audioEmitter) && isObject(%audioData = %audioEmitter.getProfileID()) && (%audioName = %audioData.uiName) !$= "")
				%f.writeLine("+-AUDIOEMITTER " @ %audioName @ "\" "); // Not sure if something else comes after the name

			if(isObject(%spawnMarker = %brick.vehicleSpawnMarker) && (%spawnMarkerName = %spawnMarker.uiName) !$= "")
				%f.writeLine("+-VEHICLE " @ %spawnMarkerName @ "\" " @ %brick.reColorVehicle);
		}

		//if($Pref::Server::AS::SlowDownAfter > 0 && %c > $Pref::Server::AS::SlowDownAfter)
		//	return schedule(1, 0, "Server_AS2_nextLine", %f, %c + 1);

		if(%noBLID)
		{
			announce("\c6[\c0!\c6] \c6CANNOT AUTOSAVE BRICKS! BL_IDs are unable to be saved! (\c3getBrickGroupFromObject(%obj) \c6is broken?\c6)");
			%f.close();
			%f.delete();
			return;
		}
		
		return schedule(0, 0, "Server_AS2_nextLine", %f, %c + 1);
	}
	else
	{
		Server_AS_SetState("(AS2) Finalize save writing");
		schedule(0, 0, Server_AS2_end, %f);
	}
}

function Server_AS2_end(%f)
{
	%f.close();
	%dir = $Pref::Server::AS::Directory;

	%date = strReplace(getDateTime(), "/", "-");
	%date = strReplace(%date, ":", ".");

	%save_time = stripChars(getWord(getDateTime(), 1), ":");

	if(!$Pref::Server::AS::OverwriteOnChange)
		$Server::AS["BrickChanged"] = 0;

	$Server::AS::RelatedBrickCount = 0;
	if($Pref::Server::AS["LastBrickCount"] == $Server::AS::Brickcount && $Pref::Server::AS["LastEventCount"] == $Server::AS::Eventcount && !$Server::AS["BrickChanged"])
		$Server::AS::RelatedBrickCount = 1;
	else
	{
		$Pref::Server::AS["LastEventCount"] = $Server::AS::Eventcount;
		$Pref::Server::AS["LastBrickCount"] = $Server::AS::Brickcount;
	}
	$Server::AS["BrickChanged"] = 0;

	if((!$Server::AS::RelatedBrickCount && !$Pref::Server::AS::SaveRelatedBrickcount) || $Pref::Server::AS::SaveRelatedBrickcount)
	{
		%direc = %dir @ "Autosave " @ getWord(%date, 0) @ " at " @ %save_time @ ".bls";
		if($CurAutoSaveName !$= "")
			%direc = %dir @ $CurAutoSaveName @ ".bls";

		if(isFile(%direc)) //Overwrite it, just delete it for sure
			fileDelete(%direc);

		if(isFile(%f.path))
			fileCopy(%f.path, %direc);
	}

	if(isFile(%f.path))
		fileDelete(%f.path);

	%f.delete();

	if($Pref::Server::AS::Interval < 5)
		$Pref::Server::AS::Interval = 1;

	if($Pref::Server::AS::Interval > 16)
		$Pref::Server::AS::Interval = 16;

	%diff = (getSimTime() - $time_beg);
	%time = %diff / 1000;
	%msg = "in \c6"@ mFloatLength(%time, 2) @" \c6second" @ (%time == 1 ? "" : "s");
	if(%time < 1)
		%msg = "\c6instantly";

	%bGroups = $Server::AS_groups::cur_group;

	if((!$Server::AS::RelatedBrickCount && !$Pref::Server::AS::SaveRelatedBrickcount) || $Pref::Server::AS::SaveRelatedBrickcount)
	{
		$Pref::Server::AS["LastAutoSave"] = fileBase(%direc);

		if($Pref::Server::AS::OverwriteSave && isFile(%f.path))
			fileCopy(%f.path, "base/server/temp/temp.bls");
	}

	if($Pref::Server::AS::Announce)
	{
		if($Server::AS::RelatedBrickCount && !$Pref::Server::AS::SaveRelatedBrickcount)
			announce("\c6[\c0!\c6] \c6Autosaved no bricks due to last save being the exact.");
		else
		{
			if($Pref::Server::AS::AnnounceSaveName)
				%saveMsg = " Saved as \c3" @ $Pref::Server::AS["LastAutoSave"] @ "\c6.";

			if($Pref::Server::AS::Report)
				%reportMsg = " \c6Saved \c3" @ $Server::AS::Eventcount @ " event" @ ($Server::AS::Eventcount == 1 ? "" : "s") @
					" \c6and \c3" @ %bGroups @ " group" @ (%bGroups == 1 ? "" : "s") @ "\c6.";

			announce("\c6[\c0!\c6] \c6Autosaved \c6" @ $Server::AS::Brickcount @" \c6brick" @ ($Server::AS::Brickcount == 1 ? "" : "s")
				@ " " @ %msg @ "\c6." @ %saveMsg @ %reportMsg);
		}
	}	

	if($Pref::Server::AS::Echo)
	{
		if($Server::AS::RelatedBrickCount && !$Pref::Server::AS::SaveRelatedBrickcount)
			echo("[AutoSaver] - Saved no bricks because it was a duplicate file.");
		else
			echo("[AutoSaver] - Autosaved " @ $Server::AS::Brickcount @ " bricks " @ %msg @ ". Saved as " @ $Pref::Server::AS["LastAutoSave"] @ ".");

		if(!$Server::AS::RelatedBrickCount)
			echo("   - Saved " @ $Server::AS::Eventcount @ " event" @ ($Server::AS::Eventcount == 1 ? "" : "s") @
				" and " @ %bGroups @ " group" @ (%bGroups == 1 ? "" : "s") @ ".");
	}

	Server_AS_SetState("(AS2) - Write complete");
	Server_AS3_ClearList(1); //Clear list will call the Server_AS1_begin, if we have a lot of bricks you'll understand why this exists.
}

function Server_AS3_ClearList(%a)
{
	if(%a)
		Server_AS_SetState("(AS3) - Clearing list");

	if(isObject(%brickList = $Server::AS::SaveObject))
	{
		$Server::AS::IsInUse = 1;
		$Server::AS::DoNotSave = true;
		if(%brickList.rowCount() == 0)
			%brickList.delete();
		else
			%brickList.removeRow(0);
	}
	else
	{
		$Server::AS::IsInUse = 0;

		Server_AS_SetState("(AS3) - Cleared list");
		%next_time = 60 * 1000 - %diff;
		%next_time = (($Pref::Server::AS::Interval | 0) * 60000 | 0) - %diff;
		if(%next_time < 60000)
			%next_time = (($Pref::Server::AS::Interval | 0) * 60000 | 0);

		cancel($Server_AS_schedule);
		$Server_AS_schedule = schedule(%next_time, 0, "Server_AS1_begin");
		$Server::AS::DoNotSave = false;
		return;
	}

	$Server::AS::ClearSch = schedule(0, 0, "Server_AS3_ClearList");
}

cancel($Server_AS_schedule);
$Server_AS_schedule = schedule((($Pref::Server::AS::Interval | 0) * 60000 | 0), 0, "Server_AS1_begin");